using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Grouping;
using System.Collections;

namespace CheckBoxRowHeader
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

       
        private void Form1_Load(object sender, System.EventArgs e)
		{
			
			DataTable dt = new DataTable("MyTable");

			int nCols = 4;
			int nRows = 5;
			Random r = new Random(15345345);
            this.gridGroupingControl1.Invalidate();
			dt.Columns.Add(new DataColumn("CheckBox", typeof(bool)));
			for(int i = 0; i < nCols; i++)
				dt.Columns.Add(new DataColumn(string.Format("Col{0}", i), typeof(int)));

			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				for(int j = 1; j < nCols; j++)
					dr[j] = r.Next(10);
				dr["Col1"] = i%5;
				dt.Rows.Add(dr);
			}

			this.gridGroupingControl1.DataSource = dt;
			this.gridGroupingControl1.TableOptions.RowHeaderWidth = 25; 
			this.gridGroupingControl1.TableDescriptor.Appearance.RowHeaderCell.CellType = "CheckBox";  
			this.gridGroupingControl1.TableDescriptor.Appearance.RowHeaderCell.CheckBoxOptions = new GridCheckBoxCellInfo("1","0","-1",false); 
			this.gridGroupingControl1.TableDescriptor.Appearance.RowHeaderCell.HorizontalAlignment = GridHorizontalAlignment.Center; 
			this.gridGroupingControl1.QueryCellStyleInfo +=new GridTableCellStyleInfoEventHandler(gridGroupingControl1_QueryCellStyleInfo);
			this.gridGroupingControl1.TableControlCheckBoxClick +=new GridTableControlCellClickEventHandler(gridGroupingControl1_TableControlCheckBoxClick);

		}
		Hashtable GroupCheckValue = new Hashtable();

		private void gridGroupingControl1_TableControlCheckBoxClick(object sender, GridTableControlCellClickEventArgs e)
		{   
			int RowIndex = e.Inner.RowIndex;
			int ColIndex = e.Inner.ColIndex;

			if( RowIndex > -1 && ColIndex > -1)
			{
				GridTableCellStyleInfo Style = e.TableControl.Model[RowIndex,ColIndex] as GridTableCellStyleInfo;   
				if( Style != null 
					&& (Style.TableCellIdentity.TableCellType == GridTableCellType.RecordRowHeaderCell 
					|| Style.TableCellIdentity.TableCellType == GridTableCellType.AlternateRecordRowHeaderCell
					|| Style.TableCellIdentity.TableCellType == GridTableCellType.AddNewRecordRowHeaderCell ) )
				{
					if( GroupCheckValue.Contains( Style.TableCellIdentity.RowIndex ))
					{
						object cellValue = GroupCheckValue[Style.TableCellIdentity.RowIndex ];
						if( cellValue != null && cellValue.ToString() != string.Empty)  
						{
							GroupCheckValue[Style.TableCellIdentity.RowIndex ] = cellValue.ToString() == "1" ? "0": "1";
						}
					}
					else
					{
						GroupCheckValue.Add( Style.TableCellIdentity.RowIndex ,"1" );	
					}
                    e.TableControl.RefreshRange(GridRangeInfo.Row(Style.TableCellIdentity.RowIndex));  
				}
			}
		}
	
		
		private void gridGroupingControl1_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
		{
            if (e.TableCellIdentity.TableCellType == GridTableCellType.RecordRowHeaderCell
                || e.TableCellIdentity.TableCellType == GridTableCellType.AlternateRecordRowHeaderCell
                || e.TableCellIdentity.TableCellType == GridTableCellType.AddNewRecordRowHeaderCell)
            {
                if (GroupCheckValue.Contains(e.TableCellIdentity.RowIndex))
                    e.Style.Text = GroupCheckValue[e.TableCellIdentity.RowIndex].ToString();

            }
            else if( e.TableCellIdentity.DisplayElement.Kind == DisplayElementKind.Record
                || e.TableCellIdentity.DisplayElement.Kind == DisplayElementKind.AddNewRecord )   
            {

                if (GroupCheckValue.Contains(e.TableCellIdentity.RowIndex) && GroupCheckValue[e.TableCellIdentity.RowIndex].ToString() == "1")
                {
                    e.Style.Enabled = false;
                    e.Style.BackColor = Color.Beige;
                }
                else
                {
                    e.Style.Enabled = true;
                    e.Style.BackColor = Color.White;
                }

            }

		}

		
	}
}

